Package org.apache.sling.thumbnails

## Interface ThumbnailSupport

    @ProviderType
    public interface ThumbnailSupport

Supports configuring which resource types should be supported as files for thumbnail generation. Each type supported must be adaptable to a java.io.InputStream.

### Method Summary

All Methods Instance Methods Abstract Methods
`@NotNull String` `getMetaTypePropertyPath​(@NotNull String resourceType)` Gets the property path for the resources's file meta type
`@NotNull Set<String>` `getPersistableTypes()` Gets all of the resource types which support persisting renditions
`@NotNull String` `getRenditionPath​(@NotNull String resourceType)` Gets the path under which to persist the renditions for the specified resource type
`@NotNull String` `getServletErrorResourcePath()` Gets the error resource path for configuring the transformation servlet
`@NotNull String` `getServletErrorSuffix()` Gets the error Suffix for configuring the transformation servlet
`@NotNull Set<String>` `getSupportedTypes()` Gets all of the resource types which support generating and transforming thumbnails.

### Method Detail

#### getMetaTypePropertyPath

    @NotNull
    @NotNull String getMetaTypePropertyPath​(@NotNull
                                            @NotNull String resourceType)

Gets the property path for the resources's file meta type

Parameters:
  `resourceType` - the resource typefor which to look up the meta type
Returns:
  the meta type path for the node type
Throws:
  `IllegalArgumentException` - the specified resource typeis not a supported

#### getPersistableTypes

    @NotNull
    @NotNull Set<String> getPersistableTypes()

Gets all of the resource types which support persisting renditions

Returns:
  the set of persistable resource types

#### getRenditionPath

    @NotNull
    @NotNull String getRenditionPath​(@NotNull
                                     @NotNull String resourceType)

Gets the path under which to persist the renditions for the specified resource type

Parameters:
  `resourceType` - the resource type to get the rendition path
Returns:
  the path under which to persist the renditions for the resource type
Throws:
  `IllegalArgumentException` - the specified resource typeis not a supported or does not support persistence

#### getServletErrorSuffix

    @NotNull
    @NotNull String getServletErrorSuffix()

Gets the error Suffix for configuring the transformation servlet

Returns:
  the error suffix for the servlet

#### getServletErrorResourcePath

    @NotNull
    @NotNull String getServletErrorResourcePath()

Gets the error resource path for configuring the transformation servlet

Returns:
  the error resource path for the servlet

#### getSupportedTypes

    @NotNull
    @NotNull Set<String> getSupportedTypes()

Gets all of the resource types which support generating and transforming thumbnails. These resource types must be adaptable to a java.io.InputStream

Returns:
  the set of supported resource types